package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZOrderDetail;
import cn.ibizlab.core.sample.filter.IBIZOrderDetailSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZOrderDetailMapper extends BaseMapper<IBIZOrderDetail> {


    Page<IBIZOrderDetail> searchCsmxdy(IPage page, @Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);
    List<IBIZOrderDetail> listCsmxdy(@Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);

    Page<IBIZOrderDetail> searchDefault(IPage page, @Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);
    List<IBIZOrderDetail> listDefault(@Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);

    Page<IBIZOrderDetail> searchLogic0007(IPage page, @Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);
    List<IBIZOrderDetail> listLogic0007(@Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);

    Page<IBIZOrderDetail> searchX(IPage page, @Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);
    List<IBIZOrderDetail> listX(@Param("ctx") IBIZOrderDetailSearchContext context, @Param("ew") Wrapper<IBIZOrderDetail> wrapper);

    @Override
    IBIZOrderDetail selectById(Serializable id);

    IBIZOrderDetail selectEntity(IBIZOrderDetail entity);

    List<IBIZOrderDetail> selectEntities(@Param("list") List<IBIZOrderDetail> list);

    @Override
    int insert(IBIZOrderDetail entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZOrderDetail entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZOrderDetail entity, @Param("ew") Wrapper<IBIZOrderDetail> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZOrderDetail> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZOrderDetail> selectByIbizOrderId(@Param("ibizOrderId") Serializable ibizOrderId);
    List<IBIZOrderDetail> selectByIbizuniProductId(@Param("ibizuniProductId") Serializable ibizuniProductId);

}